/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GoogleBigQueryDtoAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GoogleBigQueryDtoAllOf{}

// GoogleBigQueryDtoAllOf struct for GoogleBigQueryDtoAllOf
type GoogleBigQueryDtoAllOf struct {
	OAuthId   *int32  `json:"o_auth_id,omitempty"`
	ProjectId *int32  `json:"projectId,omitempty"`
	DatasetId *string `json:"datasetId,omitempty"`
	TableId   *string `json:"tableId,omitempty"`
	Statement *string `json:"statement,omitempty"`
}

// NewGoogleBigQueryDtoAllOf instantiates a new GoogleBigQueryDtoAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGoogleBigQueryDtoAllOf() *GoogleBigQueryDtoAllOf {
	this := GoogleBigQueryDtoAllOf{}
	return &this
}

// NewGoogleBigQueryDtoAllOfWithDefaults instantiates a new GoogleBigQueryDtoAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGoogleBigQueryDtoAllOfWithDefaults() *GoogleBigQueryDtoAllOf {
	this := GoogleBigQueryDtoAllOf{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *GoogleBigQueryDtoAllOf) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleBigQueryDtoAllOf) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *GoogleBigQueryDtoAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *GoogleBigQueryDtoAllOf) SetOAuthId(v int32) {
	o.OAuthId = &v
}

// GetProjectId returns the ProjectId field value if set, zero value otherwise.
func (o *GoogleBigQueryDtoAllOf) GetProjectId() int32 {
	if o == nil || IsNil(o.ProjectId) {
		var ret int32
		return ret
	}
	return *o.ProjectId
}

// GetProjectIdOk returns a tuple with the ProjectId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleBigQueryDtoAllOf) GetProjectIdOk() (*int32, bool) {
	if o == nil || IsNil(o.ProjectId) {
		return nil, false
	}
	return o.ProjectId, true
}

// HasProjectId returns a boolean if a field has been set.
func (o *GoogleBigQueryDtoAllOf) HasProjectId() bool {
	if o != nil && !IsNil(o.ProjectId) {
		return true
	}

	return false
}

// SetProjectId gets a reference to the given int32 and assigns it to the ProjectId field.
func (o *GoogleBigQueryDtoAllOf) SetProjectId(v int32) {
	o.ProjectId = &v
}

// GetDatasetId returns the DatasetId field value if set, zero value otherwise.
func (o *GoogleBigQueryDtoAllOf) GetDatasetId() string {
	if o == nil || IsNil(o.DatasetId) {
		var ret string
		return ret
	}
	return *o.DatasetId
}

// GetDatasetIdOk returns a tuple with the DatasetId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleBigQueryDtoAllOf) GetDatasetIdOk() (*string, bool) {
	if o == nil || IsNil(o.DatasetId) {
		return nil, false
	}
	return o.DatasetId, true
}

// HasDatasetId returns a boolean if a field has been set.
func (o *GoogleBigQueryDtoAllOf) HasDatasetId() bool {
	if o != nil && !IsNil(o.DatasetId) {
		return true
	}

	return false
}

// SetDatasetId gets a reference to the given string and assigns it to the DatasetId field.
func (o *GoogleBigQueryDtoAllOf) SetDatasetId(v string) {
	o.DatasetId = &v
}

// GetTableId returns the TableId field value if set, zero value otherwise.
func (o *GoogleBigQueryDtoAllOf) GetTableId() string {
	if o == nil || IsNil(o.TableId) {
		var ret string
		return ret
	}
	return *o.TableId
}

// GetTableIdOk returns a tuple with the TableId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleBigQueryDtoAllOf) GetTableIdOk() (*string, bool) {
	if o == nil || IsNil(o.TableId) {
		return nil, false
	}
	return o.TableId, true
}

// HasTableId returns a boolean if a field has been set.
func (o *GoogleBigQueryDtoAllOf) HasTableId() bool {
	if o != nil && !IsNil(o.TableId) {
		return true
	}

	return false
}

// SetTableId gets a reference to the given string and assigns it to the TableId field.
func (o *GoogleBigQueryDtoAllOf) SetTableId(v string) {
	o.TableId = &v
}

// GetStatement returns the Statement field value if set, zero value otherwise.
func (o *GoogleBigQueryDtoAllOf) GetStatement() string {
	if o == nil || IsNil(o.Statement) {
		var ret string
		return ret
	}
	return *o.Statement
}

// GetStatementOk returns a tuple with the Statement field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleBigQueryDtoAllOf) GetStatementOk() (*string, bool) {
	if o == nil || IsNil(o.Statement) {
		return nil, false
	}
	return o.Statement, true
}

// HasStatement returns a boolean if a field has been set.
func (o *GoogleBigQueryDtoAllOf) HasStatement() bool {
	if o != nil && !IsNil(o.Statement) {
		return true
	}

	return false
}

// SetStatement gets a reference to the given string and assigns it to the Statement field.
func (o *GoogleBigQueryDtoAllOf) SetStatement(v string) {
	o.Statement = &v
}

func (o GoogleBigQueryDtoAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GoogleBigQueryDtoAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["o_auth_id"] = o.OAuthId
	}
	if !IsNil(o.ProjectId) {
		toSerialize["projectId"] = o.ProjectId
	}
	if !IsNil(o.DatasetId) {
		toSerialize["datasetId"] = o.DatasetId
	}
	if !IsNil(o.TableId) {
		toSerialize["tableId"] = o.TableId
	}
	if !IsNil(o.Statement) {
		toSerialize["statement"] = o.Statement
	}
	return toSerialize, nil
}

type NullableGoogleBigQueryDtoAllOf struct {
	value *GoogleBigQueryDtoAllOf
	isSet bool
}

func (v NullableGoogleBigQueryDtoAllOf) Get() *GoogleBigQueryDtoAllOf {
	return v.value
}

func (v *NullableGoogleBigQueryDtoAllOf) Set(val *GoogleBigQueryDtoAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableGoogleBigQueryDtoAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableGoogleBigQueryDtoAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGoogleBigQueryDtoAllOf(val *GoogleBigQueryDtoAllOf) *NullableGoogleBigQueryDtoAllOf {
	return &NullableGoogleBigQueryDtoAllOf{value: val, isSet: true}
}

func (v NullableGoogleBigQueryDtoAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGoogleBigQueryDtoAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
